using System;
using System.Collections;
using System.Windows.Forms;
using RepPP;
//
// Rep++ Selection Buffer Implementation
// Copyright (C) 2003 Consyst SQL Inc.
// All Rights Reserved
//
// This source code is only intended as a supplement to the
// Rep++ Studio products.
//
//
namespace RepPP.Toolkit {
    /// <summary>
    /// The ISBFilter defines the contract a selection buffer filter must implement
    /// </summary>
    public interface ISBFilter : IDisposable {
        /// <summary>WHERE clause use in the SQL command</summary>
        string  WhereClause { get; set; }
        /// <summary>Filter criteria shown to the user</summary>
        string  FilterClause { get; set; }

        //********************************************************************************
        //
        /// <summary>
        /// ReadCardUsingFilterV:   Read a card using the filter
        /// </summary>
        /// <param name="cinst"></param>
        /// <param name="strAddWhereClause"></param>
        //
        //********************************************************************************
        void    ReadCardUsingFilterV(RepPP.CardInstance cinst, string strAddWhereClause);

        //******************************************************************
        //
        /// <summary>
        /// ReadCardUsingFilterV                Read the card using the filter
        /// </summary>
        /// <param name="cinst">                Card instance</param>
        /// <param name="strAddWhereClause">    Additionnal where clause used to filter the card</param>
        /// <param name="dataAccess">           Data access object</param>
        //
        //******************************************************************
        void    ReadCardUsingFilterV(RepPP.CardInstance cinst, string strAddWhereClause, ISBDataAccess dataAccess);
    }
}