using System;
using RepPP.Toolkit;

namespace RepPP.Toolkit.Web {

    //********************************************************************************
    //
	/// <summary>
	/// Class for Web Services object generators in C#
	/// </summary>
	//
    //********************************************************************************
	public class WebServicesGenForCS : WebServicesGenBase {
	    const string m_strCardFunc = 
@"
{0}///<summary>
{0}/// {2}SaveToObject:                      Save the card instance to the Web Services adapter object
{0}///</summary>
{0}/// <return>
{0}/// The adapter object
{0}/// </return>
{0}public virtual {1} {2}SaveToObject() {{
{0}    return({2}SaveToObject(false, RepPP.WebServicesUtil.LineTypes.AllLine));
{0}}}

{0}///<summary>
{0}/// {2}SaveToObject:                      Save the card instance to the Web Services adapter object
{0}///</summary>
{0}/// <param name=""bExtValue"">            true to use external value</param>
{0}/// <param name=""eLineType"">            Type of lines to serialize</param>
{0}/// <return>
{0}/// The adapter object
{0}/// </return>
{0}public virtual {1} {2}SaveToObject(bool bExtValue, RepPP.WebServicesUtil.LineTypes eLineType) {{
{0}    return(WebServicesUtil.SaveCInstToObject(this, bExtValue, eLineType, typeof({1})) as {1});
{0}}}

{0}///<summary>
{0}/// {2}SaveToObject:                      Save the card instance to the Web Services adapter object
{0}///</summary>
{0}/// <param name=""type"">                 Type of the object to return</param>
{0}/// <return>
{0}/// The adapter object
{0}/// </return>
{0}public virtual object {2}SaveToObject(Type type) {{
{0}    return({2}SaveToObject(false, RepPP.WebServicesUtil.LineTypes.AllLine, type));
{0}}}

{0}///<summary>
{0}/// {2}SaveToObject:                      Save the card instance to the Web Services adapter object
{0}///</summary>
{0}/// <param name=""bExtValue"">            true to use external value</param>
{0}/// <param name=""eLineType"">            Type of lines to serialize</param>
{0}/// <param name=""type"">                 Type of the object to return</param>
{0}/// <return>
{0}/// The adapter object
{0}/// </return>
{0}public virtual object {2}SaveToObject(bool bExtValue, RepPP.WebServicesUtil.LineTypes eLineType, Type type) {{
{0}    return(WebServicesUtil.SaveCInstToObject(this, bExtValue, eLineType, type));
{0}}}

{0}///<summary>
{0}/// {2}LoadFromObject:                    Load the card instance from the Web Services adapter object
{0}///</summary>
{0}/// <param name=""obj"">                  Web Services adapter object</param>
{0}public virtual void {2}LoadFromObject(object obj) {{
{0}    {2}LoadFromObject(obj, false, false);
{0}}}

{0}///<summary>
{0}/// {2}LoadFromObject:                    Load the card instance from the Web Services adapter object
{0}///</summary>
{0}/// <param name=""obj"">                  Web Services adapter object</param>
{0}/// <param name=""bExtValue"">            true to use external value</param>
{0}/// <param name=""bAppend"">              true to append the value to the card instance</param>
{0}public virtual void {2}LoadFromObject(object obj, bool bExtValue, bool bAppend) {{
{0}    RepPP.Field fldInError = null;

{0}    if (!WebServicesUtil.LoadCInstFromObject(this, bExtValue, bAppend, obj, ref fldInError)) {{
{0}        throw new System.ApplicationException(""Error in deserialization. Field in error is '"" + fldInError.Group.Name + ""."" + fldInError.Name + ""'"");
{0}    }}
{0}}}
";

	    const string m_strGroupFunc = 
@"
{0}///<summary>
{0}/// {2}SaveToArrayOfObject:               Save the card instance to the Web Services adapter object
{0}///</summary>
{0}/// <return>
{0}/// The adapter object
{0}/// </return>
{0}public virtual {1}[] {2}SaveToArrayOfObject() {{
{0}    return({2}SaveToArrayOfObject(false, RepPP.WebServicesUtil.LineTypes.AllLine));
{0}}}

{0}///<summary>
{0}/// {2}SaveToArrayOfObject:               Save the group instance to the Web Services adapter object
{0}///</summary>
{0}/// <param name=""bExtValue"">            true to use external value</param>
{0}/// <param name=""eLineType"">            Type of lines to serialize</param>
{0}/// <return>
{0}/// The adapter object
{0}/// </return>
{0}public virtual {1}[] {2}SaveToArrayOfObject(bool bExtValue, RepPP.WebServicesUtil.LineTypes eLineType) {{
{0}    return(WebServicesUtil.SaveGInstToArrayOfObject(this, bExtValue, eLineType, typeof({1})) as {1}[]);
{0}}}

{0}///<summary>
{0}/// {2}SaveToArrayOfObject:               Save the group instance to the Web Services adapter object
{0}///</summary>
{0}/// <param name=""type"">                Type of object to return</param>
{0}/// <return>
{0}/// The adapter object
{0}/// </return>
{0}public virtual object[] {2}SaveToArrayOfObject(Type type) {{
{0}    return({2}SaveToArrayOfObject(false, RepPP.WebServicesUtil.LineTypes.AllLine, type));
{0}}}

{0}///<summary>
{0}/// {2}SaveToArrayOfObject:               Save the group instance to the Web Services adapter object
{0}///</summary>
{0}/// <param name=""bExtValue"">            true to use external value</param>
{0}/// <param name=""eLineType"">            Type of lines to serialize</param>
{0}/// <param name=""type"">                 Type of object to return</param>
{0}/// <return>
{0}/// The adapter object
{0}/// </return>
{0}public virtual object[] {2}SaveToArrayOfObject(bool bExtValue, RepPP.WebServicesUtil.LineTypes eLineType, Type type) {{
{0}    return(WebServicesUtil.SaveGInstToArrayOfObject(this, bExtValue, eLineType, type));
{0}}}

{0}///<summary>
{0}/// {2}LoadFromArrayOfObject:             Load the group instance from an array of Web Services adapter objects
{0}///</summary>
{0}/// <param name=""arrObj"">               Array of Web Services adapter objects</param>
{0}public virtual void {2}LoadFromArrayOfObject(object[] arrObj) {{
{0}    {2}LoadFromArrayOfObject(arrObj, false, false);
{0}}}

{0}///<summary>
{0}/// {2}LoadFromArrayOfObject:             Load the group instance from an array of Web Services adapter objects
{0}///</summary>
{0}/// <param name=""arrObj"">               Array of Web Services adapter objects</param>
{0}/// <param name=""bExtValue"">            true to use external value</param>
{0}/// <param name=""bAppend"">              true to append the value to the card instance</param>
{0}public virtual void {2}LoadFromArrayOfObject(object[] arrObj, bool bExtValue, bool bAppend) {{
{0}    RepPP.Field fldInError = null;

{0}    if (!WebServicesUtil.LoadGInstFromArrayOfObject(this, bExtValue, bAppend, arrObj, ref fldInError)) {{
{0}        throw new System.ApplicationException(""Error in deserialization. Field in error is '"" + fldInError.Group.Name + ""."" + fldInError.Name + ""'"");
{0}    }}
{0}}}

{0}///<summary>
{0}/// {2}SaveLineToObject:                  Save the specified line to the Web Services adapter object
{0}///</summary>
{0}/// <param name=""iLineIndex"">           Index of the line to save</param>
{0}/// <return>
{0}/// The adapter object
{0}/// </return>
{0}public virtual {1} {2}SaveLineToObject(int iLineIndex) {{
{0}    return({2}SaveLineToObject(iLineIndex, false));
{0}}}

{0}///<summary>
{0}/// {2}SaveLineToObject:                  Save the specified line to the Web Services adapter object
{0}///</summary>
{0}/// <param name=""iLineIndex"">           Index of the line to save</param>
{0}/// <param name=""bExtValue"">            true to use external value</param>
{0}/// <return>
{0}/// The adapter object
{0}/// </return>
{0}public virtual {1} {2}SaveLineToObject(int iLineIndex, bool bExtValue) {{
{0}    return(WebServicesUtil.SaveLineToObject(this, bExtValue, iLineIndex, typeof({1})) as {1});
{0}}}

{0}///<summary>
{0}/// {2}SaveLineToObject:                  Save the specified line to the Web Services adapter object
{0}///</summary>
{0}/// <param name=""iLineIndex"">           Index of the line to save</param>
{0}/// <param name=""type"">                 Type of object to return</param>
{0}/// <return>
{0}/// The adapter object
{0}/// </return>
{0}public virtual object {2}SaveLineToObject(int iLineIndex, Type type) {{
{0}    return(WebServicesUtil.SaveLineToObject(this, false, iLineIndex, type));
{0}}}

{0}///<summary>
{0}/// {2}SaveLineToObject:                  Save the specified line to the Web Services adapter object
{0}///</summary>
{0}/// <param name=""iLineIndex"">           Index of the line to save</param>
{0}/// <param name=""bExtValue"">            true to use external value</param>
{0}/// <param name=""type"">                 Type of object to return</param>
{0}/// <return>
{0}/// The adapter object
{0}/// </return>
{0}public virtual object {2}SaveLineToObject(int iLineIndex, bool bExtValue, Type type) {{
{0}    return(WebServicesUtil.SaveLineToObject(this, bExtValue, iLineIndex, type));
{0}}}

{0}///<summary>
{0}/// {2}LoadLineFromObject:                Load the current line with the value of the Web Services adapter object
{0}///</summary>
{0}/// <param name=""obj"">                  Array of Web Services adapter objects</param>
{0}/// <param name=""iLineIndex"">           Index of the line to save</param>
{0}/// <return>
{0}/// Line state
{0}/// </return>
{0}public virtual RepPP.LineState {2}LoadLineFromObject(object obj, int iLineIndex) {{
{0}    return({2}LoadLineFromObject(obj, iLineIndex, false));
{0}}}

{0}///<summary>
{0}/// {2}LoadLineFromObject:                Load the current line with the value of the Web Services adapter object
{0}///</summary>
{0}/// <param name=""obj"">                  Array of Web Services adapter objects</param>
{0}/// <param name=""iLineIndex"">           Index of the line to save</param>
{0}/// <param name=""bExtValue"">            true to use external value</param>
{0}/// <return>
{0}/// Line state
{0}/// </return>
{0}public virtual RepPP.LineState {2}LoadLineFromObject(object obj, int iLineIndex, bool bExtValue) {{
{0}    return(WebServicesUtil.LoadLineFromObject(this, bExtValue, iLineIndex, obj));
{0}}}
";

        //*********************************************************	    
        //
	    /// <summary>
	    /// ctor:           Class constructor
	    /// </summary>
        //
        //*********************************************************
		public WebServicesGenForCS() {
		}

        //*********************************************************	    
        //
	    /// <summary>
	    /// GetTypeFromField:       Gets the type of a Rep++ field property
	    /// </summary>
	    /// <param name="fld">      Rep++ Field</param>
        //
        //*********************************************************
        protected virtual string GetTypeFromField(RepPP.Field fld) {
            string          strRetVal;
            RepPP.FieldType eType;
            
            if (AllPropertiesAsString) {
                strRetVal = "string";
            } else {
                eType = fld.Type;
                switch(eType) {
                case RepPP.FieldType.sdFieldDate:
                case RepPP.FieldType.sdFieldTime:
                case RepPP.FieldType.sdFieldDateTime:
                    strRetVal = "DateTime";
                    break;
                case RepPP.FieldType.sdFieldFormatString:
                case RepPP.FieldType.sdFieldHexa:
                case RepPP.FieldType.sdFieldMemo:
                case RepPP.FieldType.sdFieldMultiAlphaChoice:
                case RepPP.FieldType.sdFieldRaw:
                case RepPP.FieldType.sdFieldSimpleAlphaChoice:
                case RepPP.FieldType.sdFieldString:
                case RepPP.FieldType.sdFieldUpperString:
                    strRetVal = "string";
                    break;
                case RepPP.FieldType.sdFieldSimpleNumChoice:
                case RepPP.FieldType.sdFieldMultiNumChoice:
                    strRetVal = "int";
                    break;
                case RepPP.FieldType.sdFieldNumeric:
                    if (fld.MaxSize < 10) {
                        strRetVal = "int";
                    } else if (fld.MaxSize < 19) {
                        strRetVal = "long";
                    } else {
                        strRetVal = "decimal";
                    }
                    break;
                case RepPP.FieldType.sdFieldNumericDec:
                case RepPP.FieldType.sdFieldPercentage:
                case RepPP.FieldType.sdFieldPercentageDec:
                case RepPP.FieldType.sdFieldMoney:
                    strRetVal = "decimal";
                    break;
                default:
                    throw new ApplicationException("Unknown Rep++ type " + eType.ToString());
                }
            }
            return(strRetVal);
        }

        //*********************************************************	    
        //
	    /// <summary>
	    /// GenerateField:              Generates a field
	    /// </summary>
	    /// <param name="strFieldType"> Field type</param>
	    /// <param name="strFieldName"> Field name</param>
	    /// <param name="strIndent">    Indentation to use</param>
	    /// <param name="strRem">       Remark</param>
        //
        //*********************************************************
        protected virtual string GenerateField(string strFieldType, string strFieldName, string strIndent, string strRem) {
            string  strRetVal;
            string  strType;
            
	        strType = strFieldType.PadRight(40, ' ');
	        strRetVal = strIndent + "    ///<summary>" + PurifyRemark(strRem) + "</summary>\r\n" +
	                    strIndent +
	                    "    private " +
	                    strType +
	                    strFieldName +
	                    ";\r\n";
            return(strRetVal);
        }

        //*********************************************************	    
        //
	    /// <summary>
	    /// GenerateField:              Generates a field for a Rep++ field
	    /// </summary>
	    /// <param name="fld">          Rep++ field</param>
	    /// <param name="strIndent">    Indentation to use</param>
        //
        //*********************************************************
        protected virtual string GenerateField(RepPP.Field fld, string strIndent) {
	        return(GenerateField(GetTypeFromField(fld),
	                             "m_fld" + fld.Name,
	                             strIndent,
	                             fld.Prompt));
        }

        //*********************************************************	    
        //
	    /// <summary>
	    /// GenerateField:              Generates a field for a Rep++ card group
	    /// </summary>
	    /// <param name="cgrp">          Rep++ field</param>
	    /// <param name="strIndent">    Indentation to use</param>
        //
        //*********************************************************
        protected virtual string GenerateField(RepPP.CardGroup cgrp, string strIndent) {
	        return(GenerateField(GenerateGroupClassName(cgrp, cgrp.Group) + "[]",
	                             "m_grp" + cgrp.Group.Name,
	                             strIndent,
	                             "Group " + cgrp.Group.Name));
       }

        //*********************************************************	    
        //
	    /// <summary>
	    /// GenerateProperty:           Generates a property
	    /// </summary>
	    /// <param name="strPropType">  Property type</param>
	    /// <param name="strPropName">  Property name</param>
	    /// <param name="strFieldName"> Name of the field attached to the property</param>
	    /// <param name="strIndent">    Indentation to use</param>
	    /// <param name="strRem">       Remark</param>
	    /// <returns>
	    /// Generated property code
	    /// </returns>
        //
        //*********************************************************
        protected virtual string GenerateProperty(string strPropType, string strPropName, string strFieldName, string strIndent, string strRem) {
            string  strRetVal;
            
	        strRetVal = strIndent + "    ///<summary>" + PurifyRemark(strRem) + "</summary>\r\n" +
	                    strIndent + 
	                    "    public " + 
	                    strPropType + 
	                    " " + 
	                    strPropName +
	                    " {\r\n" +
	                    strIndent +
	                    "        get { return(" + 
	                    strFieldName + 
	                    "); } set { " + 
	                    strFieldName + 
	                    " = value; }\r\n" +
	                    strIndent + 
	                    "    }\r\n";
            return(strRetVal);
        }

        //*********************************************************	    
        //
	    /// <summary>
	    /// GenerateProperty:           Generates a property for a Rep++ field
	    /// </summary>
	    /// <param name="fld">          Rep++ field</param>
	    /// <param name="strIndent">    Indentation to use</param>
        //
        //*********************************************************
        protected virtual string GenerateProperty(RepPP.Field fld, string strIndent) {
            return(GenerateProperty(GetTypeFromField(fld),
                                    GenerateFieldPropName(fld),
                                    "m_fld" + fld.Name,
                                    strIndent,
                                    fld.Prompt));
        }

        //*********************************************************	    
        //
	    /// <summary>
	    /// GenerateProperty:           Generates a property for a Rep++ card group
	    /// </summary>
	    /// <param name="cgrp">         Rep++ card group</param>
	    /// <param name="strIndent">    Indentation to use</param>
        //
        //*********************************************************
        protected virtual string GenerateProperty(RepPP.CardGroup cgrp, string strIndent) {
            return(GenerateProperty(GenerateGroupClassName(cgrp, cgrp.Group) + "[]",
                                    GenerateCardGroupPropName(cgrp),
                                    "m_grp" + cgrp.Group.Name,
                                    strIndent,
                                    "Group " + cgrp.Group.Name));
        }

        //*********************************************************	    
        //
	    /// <summary>
	    /// GenerateGroupFields:        Generates fields to represent all Rep++ fields of a group
	    /// </summary>
	    /// <param name="cgrp">         Card group if any</param>
	    /// <param name="grp">          Rep++ group</param>
	    /// <param name="strIndent">    Indentation to use</param>
        //
        //*********************************************************
        protected virtual string GenerateGroupFields(RepPP.CardGroup cgrp, RepPP.Group grp, string strIndent) {
            System.Text.StringBuilder   strRetVal;
            
	        strRetVal = new System.Text.StringBuilder("", 4096);
	        if (cgrp != null) {
	            foreach (RepPP.CardGroup cgrpChild in cgrp.ChildCardGroups) {
	                strRetVal.Append(GenerateField(cgrpChild, strIndent));
	            }
	        } else {
	            if (AddLineState) {
	                strRetVal.Append(GenerateField("int", "m_iLineState", strIndent, "Line state"));
	            }
	            foreach (RepPP.Field fld in grp.Fields) {
	                strRetVal.Append(GenerateField(fld, strIndent));
	            }
            }
	        return(strRetVal.ToString());
        }

        //*********************************************************	    
        //
	    /// <summary>
	    /// GenerateGroupProperties:    Generates properties to represent all fields of a group
	    /// </summary>
	    /// <param name="cgrp">         Rep++ card group if any</param>
	    /// <param name="grp">          Rep++ group</param>
	    /// <param name="strIndent">    Indentation to use</param>
        //
        //*********************************************************
        protected virtual string GenerateGroupProperties(RepPP.CardGroup cgrp, RepPP.Group grp, string strIndent) {
            System.Text.StringBuilder   strRetVal;
            
	        strRetVal = new System.Text.StringBuilder("", 4096);
	        if (cgrp != null) {
	            foreach (RepPP.CardGroup cgrpChild in cgrp.ChildCardGroups) {
	                if (strRetVal.Length != 0) {
	                    strRetVal.Append("\r\n");
	                }
	                strRetVal.Append(GenerateProperty(cgrpChild, strIndent));
	            }
	        } else {
	            if (AddLineState) {
	                if (strRetVal.Length != 0) {
	                    strRetVal.Append("\r\n");
	                }
	                strRetVal.Append(GenerateProperty("int", "WSLineState", "m_iLineState", strIndent, "Line state"));
	            }
	            foreach (RepPP.Field fld in grp.Fields) {
	                if (strRetVal.Length != 0) {
	                    strRetVal.Append("\r\n");
	                }
	                strRetVal.Append(GenerateProperty(fld, strIndent));
	            }
            }
	        return(strRetVal.ToString());
        }

        //*********************************************************	    
        //
	    /// <summary>
	    /// GenerateGroupClass:                       Generates a class to use in Web Service to represent a group 
	    /// </summary>
	    /// <param name="cgrp">                       Card group if any</param>
	    /// <param name="grp">                        Rep++ group</param>
	    /// <param name="iIndent">                    Indentation to use</param>
	    /// <param name="strBaseClass">               Base class</param>
        /// <param name="strTypedInstGrpClassPrefix"> Prefix for Typed instance group class</param>
        //
        //*********************************************************
        protected virtual string GenerateGroupClass(RepPP.CardGroup cgrp, RepPP.Group grp, int iIndent, string strBaseClass, string strTypedInstGrpClassPrefix) {
            System.Text.StringBuilder   strRetVal;
            string                      strClassName;
            string                      strIndent;
            
	        strIndent       = "".PadRight(iIndent, ' ');
	        strClassName    = GenerateGroupClassName(cgrp, grp);
	        strRetVal       = new System.Text.StringBuilder("", 4096);
	        strRetVal.Append("\r\n");
	        strRetVal.Append(strIndent);
	        strRetVal.Append("///<summary>Web Services adapter class for a group</summary>\r\n");
	        strRetVal.Append(strIndent);
	        strRetVal.Append("public class ");
	        strRetVal.Append(strClassName);
	        strRetVal.Append((strBaseClass == null || strBaseClass == String.Empty) ? "" : " : " + strBaseClass);
	        strRetVal.Append(" {\r\n");
	        strRetVal.Append(GenerateGroupFields(cgrp, grp, strIndent));
	        strRetVal.Append("\r\n");
	        strRetVal.Append(GenerateGroupProperties(cgrp, grp, strIndent));
	        strRetVal.Append(strIndent);
	        strRetVal.Append("} // Class ");
	        strRetVal.Append(strClassName);
	        strRetVal.Append("\r\n");
	        if (cgrp != null) {
	            foreach (RepPP.CardGroup cgrpChild in cgrp.ChildCardGroups) {
	                strRetVal.Append(GenerateGroupClass(cgrpChild, 
                                                        cgrpChild.Group,
                                                        iIndent,
                                                        GenerateGroupBaseClassName(cgrpChild, strTypedInstGrpClassPrefix),
                                                        strTypedInstGrpClassPrefix));
	            }
	        }
	        return(strRetVal.ToString());
        }

        //*********************************************************	    
        //
	    /// <summary>
	    /// GenerateGroupClass:                       Generates a class to use in Web Service to represent a group 
	    /// </summary>
	    /// <param name="grp">                        Rep++ group</param>
	    /// <param name="iIndent">                    Indentation to use</param>
	    /// <param name="strBaseClass">               Base class</param>
        /// <param name="strTypedInstGrpClassPrefix"> Prefix for Typed instance group class</param>
        //
        //*********************************************************
        public override string GenerateGroupClass(RepPP.Group grp, int iIndent, string strBaseClass, string strTypedInstGrpClassPrefix) {
            return(GenerateGroupClass(null, grp, iIndent, strBaseClass, strTypedInstGrpClassPrefix));
        }

        //*********************************************************	    
        //
	    /// <summary>
	    /// GenerateCardClass:                        Generates a class to use in Web Service to represent a card
	    /// </summary>
	    /// <param name="crd">                        Rep++ group</param>
	    /// <param name="iIndent">                    Indentation to use</param>
	    /// <param name="strCardBaseClass">           Card Base class</param>
	    /// <param name="strGroupBaseClass">          Group Base class</param>
        /// <param name="strTypedInstGrpClassPrefix"> Prefix for Typed instance group class</param>
        //
        //*********************************************************
        public override string GenerateCardClass(RepPP.Card crd, int iIndent, string strCardBaseClass, string strGroupBaseClass, string strTypedInstGrpClassPrefix) {
            System.Text.StringBuilder   strRetVal;
            string                      strClassName;
            CardGroup                   cgrpRoot;
            string                      strIndent;

	        strIndent       = "".PadRight(iIndent, ' ');
	        strClassName    = GenerateCardClassName(crd);
	        cgrpRoot        = crd.ChildCardGroups[0];
	        strRetVal       = new System.Text.StringBuilder("", 4096);
	        strRetVal.Append(strIndent);
	        strRetVal.Append("///<summary>Web Services adapter class for a card</summary>\r\n");
	        strRetVal.Append(strIndent);
	        strRetVal.Append("public class ");
	        strRetVal.Append(strClassName);
	        strRetVal.Append((strCardBaseClass == null || strCardBaseClass == String.Empty) ? "" : " : " + strCardBaseClass);
	        strRetVal.Append(" {\r\n");
	        strRetVal.Append(GenerateField(cgrpRoot, strIndent));
	        strRetVal.Append("\r\n");
	        strRetVal.Append(GenerateProperty(cgrpRoot, strIndent));
	        strRetVal.Append(strIndent);
	        strRetVal.Append("} // Class ");
	        strRetVal.Append(strClassName);
	        strRetVal.Append("\r\n");
	        strRetVal.Append(GenerateGroupClass(cgrpRoot, 
                                                cgrpRoot.Group,
                                                iIndent,
                                                GenerateGroupBaseClassName(cgrpRoot, strTypedInstGrpClassPrefix),
                                                strTypedInstGrpClassPrefix));
	        return(strRetVal.ToString());
        }

        //*********************************************************	    
        //
	    /// <summary>
	    /// GenerateCardSerializationFunctions: Generates serialization function for the card
	    /// </summary>
	    /// <param name="strContainerClassName">Container class name</param>
	    /// <param name="crd">                  Rep++ card</param>
	    /// <param name="iIndent">              Indentation to use</param>
	    /// <returns>
	    /// Generated functions
	    /// </returns>
	    //
        //*********************************************************
        public override string GenerateCardSerializationFunctions(string strContainerClassName, RepPP.Card crd, int iIndent) {
            string      strRetVal;
            string      strClassName;
            string      strIndent;

	        strIndent       = "".PadRight(iIndent, ' ');
	        strClassName    = strContainerClassName + "." + GenerateCardClassName(crd);
	        strRetVal       = String.Format(m_strCardFunc, strIndent, strClassName, WEB_SERV_METHOD_PREFIX );
	        return(strRetVal);
	    }

        //*********************************************************	    
        //
	    /// <summary>
	    /// GenerateGroupSerializationFunctions:Generates serialization function for the card
	    /// </summary>
	    /// <param name="strContainerClassName">Container class name</param>
	    /// <param name="cgrp">                 Rep++ card group</param>
	    /// <param name="grp">                  Rep++ group</param>
	    /// <param name="iIndent">              Indentation to use</param>
	    /// <returns>
	    /// Generated functions
	    /// </returns>
	    //
        //*********************************************************
        public override string GenerateGroupSerializationFunctions(string strContainerClassName, RepPP.CardGroup cgrp, RepPP.Group grp, int iIndent) {
            string      strRetVal;
            string      strClassName;
            string      strIndent;

	        strIndent       = "".PadRight(iIndent, ' ');
	        strClassName    = strContainerClassName + "." + GenerateGroupClassName(cgrp, grp);
	        strRetVal       = String.Format(m_strGroupFunc, strIndent, strClassName, WEB_SERV_METHOD_PREFIX);
	        return(strRetVal);
	    }
	}
}
