using System;
using System.Web;
using System.Collections;
using RepPP;
using sdfwwebcsnet;

namespace RepPP.VSNetWizard
{
	/// <summary>
	/// Summary description for UserDispatch.
	/// </summary>
    internal class UserDispatch : SCDispatch {
        string                      m_strResult;        // Result string
        string                      m_strOutputDir;     // Output directory

        //******************************************************************
        //
        /// <summary>
        /// ctor:                           Class constructor
        /// </summary>
        /// <param name="app">              Rep++ application</param>
        /// <param name="strOutputDir">     Output diretory</param>
        //
        //******************************************************************        
        public UserDispatch(RepPP.IApplication app, string strOutputDir) {
            m_trc           = new SCTrace();
            m_app           = app;
            m_strOutputDir  = strOutputDir;
            m_strResult     = "";

            m_paramWeb      = CreateParameters();
            //m_session     = CreateSession();
            m_codeGen       = (RepPP.IntCodeGen)m_app.CreateExtObj(RepPP.ExtObject.sdIntCodeGen);
            if (m_codeGen == null) {
                throw new System.Exception("Unable to create the Rep++ code generator. Probably not installed!");                       
            }
        }

        //********************************************************************************
        //
        /// <summary>
        /// Write:              Write a message back to the server
        /// </summary>
        /// <param name="str">  String to write back</param>
        //
        //********************************************************************************
        public override void Write(string str) {
            m_strResult += str;
        }

        //********************************************************************************
        //
        /// <summary>
        /// GetHTTPGetVars:             Gets a list of GET variables
        /// </summary>
        /// <param name="arrVarName">   Array of variable names</param>
        /// <param name="arrVarValue">  Array of variable values</param>
        //
        //********************************************************************************
        public override void GetHTTPGetVars(out ArrayList arrVarName, out ArrayList arrVarValue) {
            arrVarName  = null;
            arrVarValue = null;
        }

        //********************************************************************************
        //
        /// <summary>
        /// GetHTTPPostVars:            Get a list of post variables.
        /// </summary>
        /// <param name="arrVarName">   Array of variable names</param>
        /// <param name="arrVarValue">  Array of variable values</param>
        //
        //********************************************************************************
        public override void GetHTTPPostVars(out ArrayList arrVarName, out ArrayList arrVarValue) {
            arrVarName  = null;
            arrVarValue = null;
        }

        //********************************************************************************
        //
        /// <summary>
        /// GetUploadedFiles:           Gets the list of file uploaded by the client
        /// </summary>
        /// <returns>
        /// List of files
        /// </returns>
        //
        //********************************************************************************
 		public override HttpFileCollection GetUploadedFiles() {
            return(null);
        }

        //********************************************************************************
        //
        /// <summary>
        /// GetHTTPCookieVar:               Gets the value of a cookie
        /// </summary>
        /// <param name="strCookieName">    Cookie name</param>
        /// <returns>
        /// Value of the cookie
        /// </returns>
        //
        //********************************************************************************
        public override string GetHTTPCookieVar(string strCookieName) {
            return(null);
        }

        //********************************************************************************
        //
        /// <summary>
        /// SetHTTPCookieVar:               Sets the value of a cookie
        /// </summary>
        /// <param name="strCookieName">    Cookie name</param>
        /// <param name="strCookieValue">   Cookie value</param>
        //
        //********************************************************************************
        public override void SetHTTPCookieVar(string strCookieName, string strCookieValue) {
        }

        //********************************************************************************
        //
        /// <summary>
        /// DeleteHTTPCookieVar:            Delete a cookie by this Name
        /// </summary>
        /// <param name="strCookieName">    Cookie name</param>
        //
        //********************************************************************************
        public override bool DeleteHTTPCookieVar(string strCookieName) {
            return(true);
        }

        //********************************************************************************
        //
        /// <summary>
        /// GetHTTPLanguage:        Gets the language asked by the browser
        /// </summary>
        /// <returns>
        /// Language identifier
        /// </returns>
        //
        //********************************************************************************
        public override string GetHTTPLanguage() {
            return("1");
        }

        //********************************************************************************
        //
        /// <summary>
        /// GetHTTPResPath:         Gets the path where to access the resources
        /// </summary>
        /// <returns>
        /// Path
        /// </returns>
        //
        //********************************************************************************
        public override string GetHTTPResPath() {
            return(m_strOutputDir);
        }

        //********************************************************************************
        //
        /// <summary>
        /// GetHTTPQuery:           Gets the query string of the request
        /// </summary>
        /// <returns>
        /// Query string
        /// </returns>
        //
        //********************************************************************************
        public  override string GetHTTPQuery() {
            return("");
        }
    } // Class UserDispatch
} // Namespace
